<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\Handler\Click;

use Flat101\EnhancedEcommerce\Helper\Config;
use Flat101\EnhancedEcommerce\Model\DataLayer\Generator\ClickImpression;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Catalog\Model\Product;

class ClickCatalogImpressionHandler implements ClickImpressionHandlerInterface
{
    private const DEFAULT_LIST = 'Catalog Products';

    /** @var Config */
    private $config;

    /** @var Session */
    private $session;

    /** @var ClickImpression */
    private $clickImpressionGenerator;

    public function __construct(
        Session $session,
        ClickImpression $clickImpressionGenerator,
        Config $config
    ) {
        $this->session = $session;
        $this->clickImpressionGenerator = $clickImpressionGenerator;
        $this->config = $config;
    }

    public function handle(Product $product, $clickData = null): void
    {
        if (!is_null($clickData)) {
            $this->session->setClickImpressionProducts(
                $this->clickImpressionGenerator->generate($product, ($clickData['list']) ?? self::DEFAULT_LIST, $clickData)
            );
        }
    }
}
