<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\Handler\Click;

use Flat101\EnhancedEcommerce\Model\DataLayer\Generator\ClickImpression;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Catalog\Model\Product;

class ClickCrossSellsImpressionHandler implements ClickImpressionHandlerInterface
{
    private const LIST = 'Cross Sells Products';

    /**
     * @var Session
     */
    private $session;

    /**
     * @var ClickImpression
     */
    private $clickImpressionGenerator;

    public function __construct(Session $session, ClickImpression $clickImpressionGenerator)
    {
        $this->session = $session;
        $this->clickImpressionGenerator = $clickImpressionGenerator;
    }

    public function handle(Product $product, $clickData = null): void
    {
        $this->session->setClickImpressionProducts(
            $this->clickImpressionGenerator->generate($product, ($clickData['list']) ?? self::LIST, $clickData)
        );
    }
}
